//***************************************************************************
// Ces applets viennent en complment du livre :
//
//  		VIE ARTIFICIELLE
//      O la biologie rencontre l'informatique
//		Illustr en Java
//            Jean-Philippe Rennard
//           	  Vuibert 2002
//===========================================================================
//  Classe abstraite de gestion du lancement d'une applet.
//    v:0.1 07/09/2002
//
//    This program is free software; you can redistribute it and/or
//    modify it under the terms of the GNU General Public License
//    as published by the Free Software Foundation.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//***************************************************************************
package vabase;

import java.awt.*;
import java.awt.event.*;
import java.applet.*;

/** Classe abstraite de lancement d'une applet */
public abstract class Claunch extends Applet {
  /** Pointeur sur l'interface utilisateur */
  public Cui Ui;
  /** Infos diverses */
  String titre, auteur, copyright, version, date;
  FlowLayout flowLayout1 = new FlowLayout();
  Button btngo = new Button();

  /** Constructeur par dfaut */
  public Claunch() {
  }
  /** Constructeur avec paramtres */
  public Claunch(String _titre, String _auteur, String _copyr,
                String _version, String _date) {
    titre=_titre;
    auteur=_auteur;
    copyright=_copyr;
    version=_version;
    date=_date;
  }

  //Initialiser l'applet
  public void init() {
    try  {
      jbInit();
    }
    catch(Exception e)  {
      e.printStackTrace();
    }
  }
  //Initialiser le composant
  private void jbInit() throws Exception {
    btngo.setLabel("Go");
    btngo.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        btngo_actionPerformed(e);
      }
    });
    this.setLayout(flowLayout1);
    this.add(btngo, null);
  }

  //Obtenir les informations de paramtre
  public String[][] getParameterInfo() {
    return null;
  }
  /** Retourne numro+date de version */
  public String getVersionNum() {
    return getVersion()+"-"+getVersionDate();
  }
  /** Retourne numro version */
  public String getVersion() {
    return "v. "+version;
  }
  /** Retourne date version */
  public String getVersionDate() {
    return date;
  }
  /** Retourne nom du programme */
  public String getName() {
    return titre;
  }
  /** Retourne auteur */
  public String getAuthor() {
    return auteur;
  }
  /** Retourne copyright */
  public String getCopyright() {
    return "Copyright(c)-"+getAuthor()+", "+copyright;
  }
  /** Dmarre l'applet et fixe la taille de sa fenetre */
  public void lancement() {
    Dimension dim= getToolkit().getScreenSize();
    Ui.setSize(Math.max((int)(0.75*dim.width),600),
                        Math.max((int)(0.75*dim.height),450));

    Ui.setLocation(20,20);
    Ui.show();
  }
  /** Appui sur le bouton de lancement dans le navigateur */
  public abstract void btngo_actionPerformed(ActionEvent e);
}